<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
               "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
		<title>Protocol Specs v1</title>
</head>
<body>
	<h1>MTALK 0.1 specification</h1>
	<h2>Intro</h2>
	<p>These are the specifications for the mtalk protocol that is used for the daemon. Clients/scripts will communicate vie this protocol. The daemon will then process and comunicate with the various protocols the daemon supports.</p>
	<h2>General Examples</h2>
	<p>Some general examples of what form the protocol is in. No commands are specified here. Only general things about the protocol.<p>
	<p>First off, all lines in the protocol end with \r\n. This is true regardless of what platform.<p>
	<p>Now to the examples: For most messages that you will see over IRC, or "single line" items, expect to use the following format.</p>
	<pre>[:&lt;nick/handle&gt; &lt;identifier&gt; [&lt;additional user info&gt;]] [:]&lt;command&gt; [&lt;params&gt; [&lt;params&gt;] ...] [:&lt;param with spaces&gt;]</pre>
	<p>For messages that need to send multiple lines, such as the PASTE function in MONONET, or any packat you can send in some chat protocols</p>
	<pre>[:&lt;nick/handle&gt; &lt;identifier&gt; [&lt;additional user info&gt;]] [:]&lt;command&gt; [&lt;params&gt; [&lt;params&gt;] ...] (&lt;packet size&gt;
&lt;param with spaces&gt;
)</pre>
	<p>Now that you can see the two forms, don't get frightend away. This is very similar to IRC, the former is basically IRC, just I have split the traditional username/hostmask/nick pattern up into something that is a tad more portable across protocols. The user information at the start only shows when you are *getting* a message from the server. When you send a message you drop the stuff at the start, and send starting with &lt;command&gt;</p>
	<p>The (&lt;packet size&gt; is a way to send multiple lines at one time. This will for example indicate that the sender watns to send multiple message or notice lines to the recipent. Some protocols support this, IRC does not support a new line without creating a whole new message. This will also potentially be used to transmit data like information in /names for IRC, and information in other parts of the protocol. As such complient clients must be able to send and parse both 'forms' of the mtalk protocol. Packet size is the size in bytes that the packet is, minus the 3 bytes taken up by the )\r\n at the end. Ie, the size of the message you are sending is the size of your package.</p>
	<h2>Connections</h2>
	<p>There must be a secure way to connect to mtalk. The primary driving reason for this is the daemon may be run as an internet facing application. This most likely should not be the default mode for the daemon, but it must be possible.</p>
	<p>To deal with this, the user setting up the server will supply a server pass of his own choosing, The server will SHA1 this pass. On connection the client will supply this same pass to the server, transmitted as an SHA1 hash. <em>The client MUST SHA1 this pass before transmitting</em>. A note about the effectiveness of this method, its not fool proof, anyone sniffing the network is going to be able to pick up this hash and potentially emulate the user. This is something that should be fixed in future versions, however some if not all protocols are vulnerable to this anyway, and send passwords in the clear. Perhaps use ssl? If so find a portable ssl library that works on all target platforms. <!-- drop a bug report in sometime --> Now down to the protocol.</p>
	<p>The order of connection methods will look as follows:</p>
	<ol>
		<li>Connecting party sends a message with pass, role and its name.</li>
		<li>Daemon responds saying it has the connection, and or not authorized.</li>
	</ol>
	<h3>Connection message</h3>
	<p><b>Command:</b> C</p>
	<p><b>Params</b> &lt;pass&gt; &lt;role&gt; &lt;name&gt;</p>
	<p>All clients, plugins, protocol handlers will send this line to the daemon. No plugin or module is exempt from this step. A key fact to note, as this initial system is based on one user using the daemon, the password for all connecting modules will be the same. It is presmed the user keeps this pass in secret.</p>
	<p>&lt;role&gt;: Role of the plugin. As of this writing there are three lanned roles. Modules can assume one of the three: client, traditional plugin (think irssi/xchat/whatever plugin), and protocol parser. These should be explained elsewhere in this document. Once a module is registered as a role, it cannot change its role.</p>
	<p>&lt;name&gt;: Modules have names, this is where the name is provided. These can be useful to be called up by other modules to see what is currently running on the daemon. Modules will have the ability to set optional values of their own choosing. (this will again be discribed elsewhere).</p>
	<h3>Connection response</h3>
	<p>Connection response on success will be RPL_ACCEPTED. Upon receipt of this message, the module can start its duties, ask for information, send information etc. Please look at the end of this document for a list of standard replies and their parameters. This is one of them.</p>
	<p>On failure to log in, you will get ERR_BADPASS. Depending on the setup, future versions of the daemon may refuse connections past X failed login attempts.</p>
	<p>On bad syntax, you will get ERR_SYNTAX, fix your syntax and try again.</p>



</body>
